<?php
/*
Plugin Name: Page Dump
Plugin URI: http://www.almosteffortless.com/wordpress/
Description: This plugin allows you to dump the content of your Wordpress Pages onto a single webpage. Enable the plugin and append "?page_dump=1" to your site's URL like so: "http://example.com/?page_dump=1" to see the results.
Author: Trevor Turk
Version: 1.0
Author URI: http://www.almosteffortless.com/
*/ 

/*  Copyright 2006  Trevor Turk  (email : trevorturk@yahoo.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function page_dump($parent = 0, $level = 0, $pages = 0) {
	
	if ($_GET['page_dump'] == "1") { 
	
	global $wpdb, $class, $post, $post_ID;
				
		echo "<html><head><title>".get_bloginfo()."</title></head><body><h1>".get_bloginfo()."</h1><hr>\n";
				
				$r['depth'] = 0;
				$r['show_date'] = '';
				$r['child_of'] = 0;
				$r['title_li'] = 'Pages';
				$r['echo'] = 1;
				
			$output = '';

			// Query pages.
			$pages = & get_pages('sort_column=menu_order');
			if ( $pages ) {

				// Now loop over all pages that were selected
				$page_tree = Array();
				foreach ( $pages as $page ) {
					// set the title for the current page
					$page_tree[$page->ID]['title'] = $page->post_title;
					$page_tree[$page->ID]['content'] = $page->post_content;

					// The tricky bit!!
					// Using the parent ID of the current page as the
					// array index we set the curent page as a child of that page.
					// We can now start looping over the $page_tree array
					// with any ID which will output the page links from that ID downwards.
					if ( $page->post_parent != $page->ID)
						$page_tree[$page->post_parent]['children'][] = $page->ID;
				}
				// Output of the pages starting with child_of as the root ID.
				// child_of defaults to 0 if not supplied in the query.
				$output .= _page_level_out_dump($r['child_of'],$page_tree, $r, 0, false);
			}

			echo $output;
		
		echo "\n<p style='text-align:right'>" . date('F j, Y') . "</p>\n";
		echo "\n</body></html>";
		exit;
	}
}

function _page_level_out_dump($parent, $page_tree, $args, $depth = 0, $echo = true) {
	global $wp_query;
	$queried_obj = $wp_query->get_queried_object();
	$output = '';

	if ( $depth )
		$indent = str_repeat("&mdash;&nbsp;", $depth);

	if ( !is_array($page_tree[$parent]['children']) )
		return false;

	foreach ( $page_tree[$parent]['children'] as $page_id ) {
		$cur_page = $page_tree[$page_id];
		$title = $cur_page['title'];
		$content = $cur_page['content'];
		
		$output .= "\n<h2>" . $indent . wp_specialchars($title) . "</h2>\n";
		
		$output .= $content;
		
		$output .= "\n<hr>\n";	

		if ( isset($cur_page['children']) && is_array($cur_page['children']) ) {
			$new_depth = $depth + 1;

			if ( !$args['depth'] || $depth < ($args['depth']-1) ) {
				$output .= _page_level_out_dump($page_id, $page_tree, $args, $new_depth, false);
			}
		}
	}
	if ( $echo )
		echo $output;
	else
		return $output;
}

	add_action('template_redirect', 'page_dump');

?>